hack/make.sh
b1953bab
 #!/usr/bin/env bash
83a2e92d
 set -e
89ee5242
 
d9f76993
 # This script builds various binary artifacts from a checkout of the docker
 # source code.
89ee5242
 #
 # Requirements:
d9f76993
 # - The current directory should be a checkout of the docker source code
 #   (http://github.com/dotcloud/docker). Whatever version is checked out
 #   will be built.
 # - The VERSION file, at the root of the repository, should exist, and
 #   will be used as Docker binary version and package version.
 # - The hash of the git commit will also be included in the Docker binary,
a8059059
 #   with the suffix -dirty if the repository isn't clean.
d14058bc
 # - The script is intented to be run inside the docker container specified
d9f76993
 #   in the Dockerfile at the root of the source. In other words:
 #   DO NOT CALL THIS SCRIPT DIRECTLY.
83d81758
 # - The right way to call this script is to invoke "make" from
b3d5e952
 #   your checkout of the Docker repository.
2a1181f4
 #   the Makefile will do a "docker build -t docker ." and then
a0505edc
 #   "docker run hack/make.sh" in the resulting image.
aa3de0b8
 #
89ee5242
 
83a2e92d
 set -o pipefail
89ee5242
 
749a7d0e
 # We're a nice, sexy, little shell script, and people might try to run us;
 # but really, they shouldn't. We want to be in a container!
b994c131
 if [ "$(pwd)" != '/go/src/github.com/dotcloud/docker' ] || [ -z "$DOCKER_CROSSPLATFORMS" ]; then
 	{
 		echo "# WARNING! I don't seem to be running in the Docker container."
 		echo "# The result of this command might be an incorrect build, and will not be"
 		echo "#   officially supported."
 		echo "#"
 		echo "# Try this instead: make all"
 		echo "#"
 	} >&2
 fi
 
 echo
749a7d0e
 
3d39336a
 # List of bundles to create when no argument is passed
 DEFAULT_BUNDLES=(
81370b5b
 	validate-dco
 	validate-gofmt
 	
3d39336a
 	binary
81370b5b
 	
a39f3c92
 	test-unit
f0879a1e
 	test-integration
2543912e
 	test-integration-cli
81370b5b
 	
21161dbd
 	dynbinary
986a151b
 	dyntest-unit
f0879a1e
 	dyntest-integration
81370b5b
 	
59dc2876
 	cover
62a81370
 	cross
b3f5973f
 	tgz
3d39336a
 	ubuntu
 )
 
d9f76993
 VERSION=$(cat ./VERSION)
0a040645
 if command -v git &> /dev/null && git rev-parse &> /dev/null; then
efd0e13c
 	GITCOMMIT=$(git rev-parse --short HEAD)
0a040645
 	if [ -n "$(git status --porcelain --untracked-files=no)" ]; then
efd0e13c
 		GITCOMMIT="$GITCOMMIT-dirty"
 	fi
 elif [ "$DOCKER_GITCOMMIT" ]; then
 	GITCOMMIT="$DOCKER_GITCOMMIT"
 else
 	echo >&2 'error: .git directory missing and DOCKER_GITCOMMIT not specified'
 	echo >&2 '  Please either build with the .git directory accessible, or specify the'
 	echo >&2 '  exact (--short) commit hash you are building using DOCKER_GITCOMMIT for'
 	echo >&2 '  future accountability in diagnosing build issues.  Thanks!'
 	exit 1
5b630d43
 fi
89ee5242
 
d3d85d38
 if [ "$AUTO_GOPATH" ]; then
 	rm -rf .gopath
 	mkdir -p .gopath/src/github.com/dotcloud
 	ln -sf ../../../.. .gopath/src/github.com/dotcloud/docker
 	export GOPATH="$(pwd)/.gopath:$(pwd)/vendor"
 fi
 
 if [ ! "$GOPATH" ]; then
 	echo >&2 'error: missing GOPATH; please see http://golang.org/doc/code.html#GOPATH'
 	echo >&2 '  alternatively, set AUTO_GOPATH=1'
 	exit 1
 fi
 
b187cc40
 # Use these flags when compiling the tests and final binary
be344cf0
 LDFLAGS='
 	-w
 	-X github.com/dotcloud/docker/dockerversion.GITCOMMIT "'$GITCOMMIT'"
 	-X github.com/dotcloud/docker/dockerversion.VERSION "'$VERSION'"
 '
 LDFLAGS_STATIC='-linkmode external'
 EXTLDFLAGS_STATIC='-static'
d4725801
 BUILDFLAGS=( -a -tags "netgo static_build $DOCKER_BUILDTAGS" )
b187cc40
 
be344cf0
 # A few more flags that are specific just to building a completely-static binary (see hack/make/binary)
 # PLEASE do not use these anywhere else.
 EXTLDFLAGS_STATIC_DOCKER="$EXTLDFLAGS_STATIC -lpthread -Wl,--unresolved-symbols=ignore-in-object-files"
 LDFLAGS_STATIC_DOCKER="
 	$LDFLAGS_STATIC
 	-X github.com/dotcloud/docker/dockerversion.IAMSTATIC true
 	-extldflags \"$EXTLDFLAGS_STATIC_DOCKER\"
 "
 
18bea249
 if [ "$(uname -s)" = 'FreeBSD' ]; then
 	# Tell cgo the compiler is Clang, not GCC
 	# https://code.google.com/p/go/source/browse/src/cmd/cgo/gcc.go?spec=svne77e74371f2340ee08622ce602e9f7b15f29d8d3&r=e6794866ebeba2bf8818b9261b54e2eef1c9e588#752
 	export CC=clang
 
 	# "-extld clang" is a workaround for
 	# https://code.google.com/p/go/issues/detail?id=6845
 	LDFLAGS="$LDFLAGS -extld clang"
 fi
 
92ea101b
 # If sqlite3.h doesn't exist under /usr/include,
 # check /usr/local/include also just in case
 # (e.g. FreeBSD Ports installs it under the directory)
 if [ ! -e /usr/include/sqlite3.h ] && [ -e /usr/local/include/sqlite3.h ]; then
 	export CGO_CFLAGS='-I/usr/local/include'
 	export CGO_LDFLAGS='-L/usr/local/lib'
 fi
 
59dc2876
 HAVE_GO_TEST_COVER=
eddda577
 if \
ad80da33
 	go help testflag | grep -- -cover > /dev/null \
eddda577
 	&& go tool -n cover > /dev/null 2>&1 \
 ; then
59dc2876
 	HAVE_GO_TEST_COVER=1
 fi
 
dcfc4ada
 # If $TESTFLAGS is set in the environment, it is passed as extra arguments to 'go test'.
 # You can use this to select certain tests to run, eg.
 #
 #   TESTFLAGS='-run ^TestBuild$' ./hack/make.sh test
 #
 go_test_dir() {
 	dir=$1
b3d5e952
 	coverpkg=$2
59dc2876
 	testcover=()
 	if [ "$HAVE_GO_TEST_COVER" ]; then
 		# if our current go install has -cover, we want to use it :)
 		mkdir -p "$DEST/coverprofiles"
 		coverprofile="docker${dir#.}"
 		coverprofile="$DEST/coverprofiles/${coverprofile//\//-}"
b3d5e952
 		testcover=( -cover -coverprofile "$coverprofile" $coverpkg )
59dc2876
 	fi
dcfc4ada
 	(
e1c48fa5
 		echo '+ go test' $TESTFLAGS "github.com/dotcloud/docker${dir#.}"
dcfc4ada
 		cd "$dir"
0b23393b
 		go test ${testcover[@]} -ldflags "$LDFLAGS" "${BUILDFLAGS[@]}" $TESTFLAGS
dcfc4ada
 	)
 }
 
b3d5e952
 # This helper function walks the current directory looking for directories
 # holding certain files ($1 parameter), and prints their paths on standard
 # output, one per line.
 find_dirs() {
66baf566
 	find . -not \( \
99b63647
 		\( \
 			-wholename './vendor' \
 			-o -wholename './integration' \
6db32fde
 			-o -wholename './integration-cli' \
99b63647
 			-o -wholename './contrib' \
 			-o -wholename './pkg/mflag/example' \
 			-o -wholename './.git' \
 			-o -wholename './bundles' \
 			-o -wholename './docs' \
3986bc65
 			-o -wholename './pkg/libcontainer/nsinit' \
99b63647
 		\) \
b3d5e952
 		-prune \
 	\) -name "$1" -print0 | xargs -0n1 dirname | sort -u
 }
 
6b46a091
 hash_files() {
 	while [ $# -gt 0 ]; do
 		f="$1"
 		shift
 		dir="$(dirname "$f")"
 		base="$(basename "$f")"
 		for hashAlgo in md5 sha256; do
 			if command -v "${hashAlgo}sum" &> /dev/null; then
 				(
 					# subshell and cd so that we get output files like:
 					#   $HASH docker-$VERSION
 					# instead of:
 					#   $HASH /go/src/github.com/.../$VERSION/binary/docker-$VERSION
 					cd "$dir"
 					"${hashAlgo}sum" "$base" > "$base.$hashAlgo"
 				)
 			fi
 		done
 	done
 }
 
3d39336a
 bundle() {
 	bundlescript=$1
 	bundle=$(basename $bundlescript)
aa3de0b8
 	echo "---> Making bundle: $bundle (in bundles/$VERSION/$bundle)"
3d39336a
 	mkdir -p bundles/$VERSION/$bundle
 	source $bundlescript $(pwd)/bundles/$VERSION/$bundle
89ee5242
 }
 
 main() {
aa3de0b8
 	# We want this to fail if the bundles already exist and cannot be removed.
3d39336a
 	# This is to avoid mixing bundles from different versions of the code.
 	mkdir -p bundles
 	if [ -e "bundles/$VERSION" ]; then
 		echo "bundles/$VERSION already exists. Removing."
 		rm -fr bundles/$VERSION && mkdir bundles/$VERSION || exit 1
aa3de0b8
 		echo
3d39336a
 	fi
 	SCRIPTDIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
 	if [ $# -lt 1 ]; then
85956c70
 		bundles=(${DEFAULT_BUNDLES[@]})
3d39336a
 	else
 		bundles=($@)
 	fi
 	for bundle in ${bundles[@]}; do
 		bundle $SCRIPTDIR/make/$bundle
aa3de0b8
 		echo
3d39336a
 	done
89ee5242
 }
 
3d39336a
 main "$@"